#TEMPLATE(hjTPL, 'Harley''s Templates'), FAMILY('ABC')
#!-----------------------------------------------------------------------------
#CONTROL(hjBrowseRefreshButton, 'HJ: Refresh a Browse Box'), DESCRIPTION('HJ: Refresh the Browse on ' & %Primary), REQ(BrowseBox(ABC))
#!
  CONTROLS
    BUTTON, AT(, , 12, 12), USE(?Refresh), FLAT, ICON('refresh.16.gif')
  END
#!
#PROMPT('Template Enabled', CHECK), %TemplateEnabled, AT(10), DEFAULT(%True)
#ENABLE(%TemplateEnabled)
  #BOXED('Refresh Button')
    #PROMPT('Select from Popup', CHECK), %SelectFromPopup, DEFAULT(%True), AT(10)
    #PROMPT('Alert Key:', KEYCODE), %KeyCode, DEFAULT('F5Key')
  #ENDBOXED
#ENDENABLE
#!
#ATSTART
  #DECLARE(%RefreshControl)
  #FOR(%Control), WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%RefreshControl, %Control)
  #ENDFOR
  #IF(%TemplateEnabled)
    #! Add Custom Properties
    #CALL(%AddProperty, 'RefreshControl', 'LONG')
    #! Add Custom Methods
    #CALL(%AddMethod, 'Refresh', '()')
  #ELSE
    #! Remove Custom Properties
    #CALL(%RemoveProperty, 'RefreshControl')
    #! Remove Custom Methods
    #CALL(%RemoveMethod, 'Refresh', '()')
  #ENDIF
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection, 'Init', '(),BYTE'), PRIORITY(9550), WHERE(%TemplateEnabled)
%ManagerName.RefreshControl = %RefreshControl
  #IF(%SelectFromPopup)
%ManagerName.Popup.AddItemMimic('Refresh', %ManagerName.RefreshControl, 'Refresh')
  #ENDIF
  #IF(%KeyCode <> '')
%ListControl{PROP:Alrt, 255} = %KeyCode
  #ENDIF
#ENDAT
#!
#AT(%BrowserMethodCodeSection, %ActiveTemplateParentInstance, 'TakeKey', '(),BYTE'), PRIORITY(5500), WHERE(%KeyCode)
IF KEYCODE() = %KeyCode
  SELF.Refresh()
  ReturnValue = 1
END
#ENDAT
#!
#AT(%ControlEventHandling, %RefreshControl, 'Accepted'), WHERE(%TemplateEnabled)
%ManagerName.Refresh()
#ENDAT
#!
#AT(%NewMethodDataSection, %ActiveTemplateParentInstance, %ClassItem), WHERE(%TemplateEnabled AND %NewMethodName = 'Refresh' AND %NewMethodPrototype = '()')
FakeRequest          BYTE(ViewRecord)
FakeResponse         BYTE(RequestCompleted)
#ENDAT
#!
#AT(%NewMethodCodeSection, %ActiveTemplateParentInstance, %ClassItem), WHERE(%TemplateEnabled AND %NewMethodName = 'Refresh' AND %NewMethodPrototype = '()')
SELF.ResetFromAsk(FakeRequest, FakeResponse)
#ENDAT
#!-----------------------------------------------------------------------------
#GROUP(%RemoveMethod, STRING %pMethodName, STRING %pMethodPrototype), PRESERVE
  #DECLARE(%MethodInstance)
  #SET(%MethodInstance, 0)
  #FOR(%NewMethods)
    #IF(UPPER(%NewMethodName) = UPPER(%pMethodName) AND UPPER(%NewMethodPrototype) = UPPER(%pMethodPrototype))
      #SET(%MethodInstance, INSTANCE(%NewMethods))
      #BREAK
    #ENDIF
  #ENDFOR
  #IF(%MethodInstance <> 0)
    #DELETE(%NewMethods, %MethodInstance)
  #ENDIF
  #IF(ITEMS(%NewClassPropertyItems) = 0 AND ITEMS(%NewMethods) = 0)
    #SET(%DeriveFromBaseClass, %False)
  #ENDIF
#!-----------------------------------------------------------------------------
#GROUP(%RemoveProperty, STRING %pClassProperty), PRESERVE
  #DECLARE(%PropertyInstance)
  #SET(%PropertyInstance, 0)
  #FOR(%NewClassPropertyItems)
    #IF(UPPER(%NewClassProperty) = UPPER(%pClassProperty))
      #SET(%PropertyInstance, INSTANCE(%NewClassPropertyItems))
      #BREAK
    #ENDIF
  #ENDFOR
  #IF(%PropertyInstance <> 0)
    #DELETE(%NewClassPropertyItems, %PropertyInstance)
  #ENDIF
  #IF(ITEMS(%NewClassPropertyItems) = 0 AND ITEMS(%NewMethods) = 0)
    #SET(%DeriveFromBaseClass, %False)
  #ENDIF
#!-----------------------------------------------------------------------------
#GROUP(%AddProperty, STRING %pClassProperty, STRING %pClassDataType), PRESERVE
  #DECLARE(%PropertyPresent)
  #DECLARE(%LastInstance)
  #SET(%PropertyPresent, %False)
  #SET(%LastInstance, 0)
  #FOR(%NewClassPropertyItems)
    #IF(%LastInstance < %NewClassPropertyItems)
      #SET(%LastInstance, %NewClassPropertyItems)
    #ENDIF
    #IF(UPPER(%NewClassProperty) = UPPER(%pClassProperty))
      #SET(%PropertyPresent, %True)
      #BREAK
    #ENDIF
  #ENDFOR
  #IF(%PropertyPresent = %False)
    #ADD(%NewClassPropertyItems, %LastInstance + 1)
    #SET(%NewClassProperty, %pClassProperty)
    #SET(%NewClassDataType, %pClassDataType)
  #ENDIF
  #SET(%DeriveFromBaseClass, %True)
#!-----------------------------------------------------------------------------
#GROUP(%AddMethod, STRING %pMethodName, STRING %pMethodPrototype), PRESERVE
  #DECLARE(%MethodPresent)
  #DECLARE(%LastInstance)
  #SET(%MethodPresent, %False)
  #SET(%LastInstance, 0)
  #FOR(%NewMethods)
    #IF(%LastInstance < %NewMethods)
      #SET(%LastInstance, %NewMethods)
    #ENDIF
    #IF(UPPER(%NewMethodName) = UPPER(%pMethodName) AND UPPER(%NewMethodPrototype) = UPPER(%pMethodPrototype))
      #SET(%MethodPresent, %True)
      #BREAK
    #ENDIF
  #ENDFOR
  #IF(%MethodPresent = %False)
    #ADD(%NewMethods, %LastInstance + 1)
    #SET(%NewMethodName, %pMethodName)
    #SET(%NewMethodPrototype, %pMethodPrototype)
  #END
  #SET(%DeriveFromBaseClass, %True)

