!ABCIncludeFile
!========================================
! Copyright  2001 by Carl Barnes
! True failure of swlwapi.dll loading has not actually been tested
! Test with IE3 and IE4, under Win95 and NT4 before release
!========================================

 OMIT('_EndOfInclude_',_CBSHAutoComplete_)
_CBSHAutoComplete_ EQUATE(1)

SHACF_DEFAULT       EQUATE(00000000h)  !SHACF_DEFAULT 0x00000000 // Currently (SHACF_FILESYSTEM | SHACF_URLALL)
SHACF_FILESYSTEM    EQUATE(00000001h)  !SHACF_FILESYSTEM 0x00000001 // This includes the File System as well as the rest of the shell (Desktop\My Computer\Control Panel\)
SHACF_URLHISTORY    EQUATE(00000002h)  !SHACF_URLHISTORY 0x00000002 // URLs in the User's History
SHACF_URLMRU        EQUATE(00000004h)  !SHACF_URLMRU 0x00000004 // URLs in the User's Recently Used list.
SHACF_URLALL        EQUATE(BOR(SHACF_URLHISTORY , SHACF_URLMRU))  !SHACF_URLALL (SHACF_URLHISTORY | SHACF_URLMRU)
SHACF_ALL           EQUATE(BOR(SHACF_FILESYSTEM , SHACF_URLALL))  !Carl Added for All Types

!SHACF_FILESYS_ONLY Must be used in with SHACF_FILESYSTEM i.e. SHACF_FILESYS_ONLY+SHACF_FILESYSTEM
SHACF_FILESYS_ONLY  EQUATE(00000010h)                   !SHACF_FILESYS_ONLY 0x00000010 // Don't AutoComplete non-File System items.
SHACF_FILESONLY     EQUATE(BOR(SHACF_FILESYSTEM , SHACF_FILESYS_ONLY))   !Carl Made to Get Files only

SHACF_USETAB        EQUATE(00000008h)   !User can press TAB to complete - why do this?

!If these flags are not specified then the Users choices from the IE Options Advanaced Tab are used
!is is possible to have AutoSuggest (drop list) and AutoAppend (append to entry) at the same time
SHACF_AUTOSUGGEST_FORCE_ON  EQUATE(10000000h)  !Ignore the registry value and force the autosuggest mode on. A selection of possible completed strings will be displayed as a drop-down list, below the edit box. Ignore the registry default and force the feature on.
SHACF_AUTOSUGGEST_FORCE_OFF EQUATE(20000000h)  !Ignore the registry default and force the autosuggest mode off.  Ignore the registry default and force the feature off.
SHACF_AUTOAPPEND_FORCE_ON   EQUATE(40000000h)  !Ignore the registry value and force the autoappend mode on.  Ignore the registry default and force the feature on. (Also know as AutoComplete)
SHACF_AUTOAPPEND_FORCE_OFF  EQUATE(80000000h)  !Ignore the registry default and force the autoappend mode off. Ignore the registry default and force the feature off. (Also know as AutoComplete)

!I Created these "Easy Input" equates to make it easy to forget the above equates and pick one of 3 types
SHACR_MODE         EQUATE(SHACF_AUTOSUGGEST_FORCE_ON + SHACF_AUTOAPPEND_FORCE_OFF) !Suggest Mode Only is my desired mode
SHACR_INPUT_FILE   EQUATE(SHACR_MODE + SHACF_FILESYSTEM + SHACF_FILESYS_ONLY)
SHACR_INPUT_URL    EQUATE(SHACR_MODE + SHACF_URLALL)
SHACR_INPUT_ALL    EQUATE(SHACR_MODE + SHACF_URLALL + SHACF_FILESYSTEM + SHACF_FILESYS_ONLY)

!=======================================================================
! SHAutoCompleteClass
!=======================================================================
SHAutoCompleteClass   CLASS, TYPE, MODULE('CBSHAuto.clw'), LINK('CBSHAuto.clw',_ABCLinkMode_), |
                                DLL(_ABCDllMode_)
!Call these methods to enable AutoComplete for a TEXT control and pass ?PreField
!Returns 0=Ok 1=Error linke ABC. Check .LastHResult for API Error
Input_File             PROCEDURE(LONG TextFEQ),LONG,PROC,VIRTUAL
Input_URL              PROCEDURE(LONG TextFEQ),LONG,PROC,VIRTUAL
Input_All              PROCEDURE(LONG TextFEQ, LONG Flags=SHACR_INPUT_ALL),LONG,PROC,VIRTUAL

Init                   PROCEDURE(),LONG,VIRTUAL        !Returns 0=Ok You do not need to call Init but can

Construct              PROCEDURE(),PROTECTED
Destruct               PROCEDURE(),PROTECTED

    !Data Items, InitStatus MUST be First so it is DWord aligned in C6
InitStatus             LONG,PROTECTED              !1=Yes 0=No -1=Failed Inited

CoInitialized          BYTE,PRIVATE                 !Did CoInitialize work in the Constructor?

LastHResult            LONG       !If prior call to SHAutoComplete failed this will be the HResult
                END

_EndOfInclude_