    program

DWORD          EQUATE(LONG)
WORD           EQUATE(USHORT)
HRESULT        EQUATE(LONG)
HWND           EQUATE(UNSIGNED)
UINT           EQUATE(UNSIGNED)
OLESTRING      EQUATE(BSTRING)


               MAP
                 MODULE('')
CoInitialize       PROCEDURE (<*LONG>),HRESULT,RAW,PROC,PASCAL
CoUninitialize     PROCEDURE (),RAW,PASCAL
                 END

                 !Should LoadLib and Getproc
                 module('shlwapi.lib')
                    !SHAutoComplete(HWND hwndEdit,DWORD dwFlags),HRESULT,RAW,PROC,PASCAL
                    SHAutoComplete(HWND hwndEdit,DWORD dwFlags),HRESULT,PASCAL,PROC
                    !SHAutoComplete(long hwndEdit,long dwFlags),long,PROC,PASCAL
                end
               END

S_OK                EQUATE(0)          !Normal COM success value

SHACF_DEFAULT       EQUATE(00000000h)  !SHACF_DEFAULT 0x00000000 // Currently (SHACF_FILESYSTEM | SHACF_URLALL)
SHACF_FILESYSTEM    EQUATE(00000001h)  !SHACF_FILESYSTEM 0x00000001 // This includes the File System as well as the rest of the shell (Desktop\My Computer\Control Panel\)
SHACF_URLHISTORY    EQUATE(00000002h)  !SHACF_URLHISTORY 0x00000002 // URLs in the User's History
SHACF_URLMRU        EQUATE(00000004h)  !SHACF_URLMRU 0x00000004 // URLs in the User's Recently Used list.

SHACF_URLALL        EQUATE(BOR(SHACF_URLHISTORY , SHACF_URLMRU))  !SHACF_URLALL (SHACF_URLHISTORY | SHACF_URLMRU)

SHACF_ALL           EQUATE(BOR(SHACF_FILESYSTEM , SHACF_URLALL))  !Carl Added for All Types

!SHACF_FILESYS_ONLY Must be used in with SHACF_FILESYSTEM i.e. SHACF_FILESYS_ONLY+SHACF_FILESYSTEM
SHACF_FILESYS_ONLY                EQUATE(00000010h)                   !SHACF_FILESYS_ONLY 0x00000010 // Don't AutoComplete non-File System items.
SHACF_FILESONLY                   EQUATE(BOR(SHACF_FILESYSTEM , SHACF_FILESYS_ONLY))   !Carl Made to Get Files only

SHACF_USETAB                      EQUATE(00000008h)                   !SHACF_USETAB 0x00000008 // User can press TAB to complete

!If these flags are not specified then the Uses choices from the IE Options Advanaced Tab are used
!is is possible to have AutoSuggest (drop list) and AutoAppend (append to entry) at the same time
SHACF_AUTOSUGGEST_FORCE_ON  EQUATE(10000000h)  !Ignore the registry value and force the autosuggest mode on. A selection of possible completed strings will be displayed as a drop-down list, below the edit box. Ignore the registry default and force the feature on.
SHACF_AUTOSUGGEST_FORCE_OFF EQUATE(20000000h)  !Ignore the registry default and force the autosuggest mode off.  Ignore the registry default and force the feature off.
SHACF_AUTOAPPEND_FORCE_ON   EQUATE(40000000h)  !Ignore the registry value and force the autoappend mode on.  Ignore the registry default and force the feature on. (Also know as AutoComplete)
SHACF_AUTOAPPEND_FORCE_OFF  EQUATE(80000000h)  !Ignore the registry default and force the autoappend mode off. Ignore the registry default and force the feature off. (Also know as AutoComplete)

!I Created these equates to make it easy to forget the above equates and pick one of 3 types
SHACR_MODE         EQUATE(SHACF_AUTOSUGGEST_FORCE_ON + SHACF_AUTOAPPEND_FORCE_OFF) !Suggest Mode Only is my desired mode
SHACR_INPUT_FILE   EQUATE(SHACR_MODE + SHACF_FILESYSTEM + SHACF_FILESYS_ONLY)
SHACR_INPUT_URL    EQUATE(SHACR_MODE + SHACF_URLALL)
SHACR_INPUT_ALL    EQUATE(SHACR_MODE + SHACF_URLALL + SHACF_FILESYSTEM + SHACF_FILESYS_ONLY)


hr      HResult

!1. ENTRY controls do not work, TEXT controls do
!2. In C5 Tab key does not work to exit the control, event if I add the SHACF_USETAB flag
!     Tab works fine in C55 and C6 w/o SHACF_USETAB

T_DEFAULT            STRING(260)  !SHACF_DEFAULT
T_FILESYSTEM         STRING(260)  !SHACF_FILESYSTEM
T_FILESYS_ONLY       STRING(260)  !SHACF_FILESYS_ONLY
T_FILESYS_ONLY_A     STRING(260)  !SHACF_FILESYS_ONLY+SHACF_FILESYSTEM
T_URLHISTORY         STRING(260)  !SHACF_URLHISTORY
T_URLMRU             STRING(260)  !SHACF_URLMRU
T_URLALL             STRING(260)  !SHACF_URLALL
T_ALL                STRING(260)  !BOR(SHACF_FILESYSTEM , SHACF_URLALL)

M_DEFAULT STRING(260)  ! No AUTO Equates')
M_Suggest STRING(260)  ! SHACF_AUTOSUGGEST_FORCE_ON  + SHACF_AUTOAPPEND_FORCE_OFF
M_Append  STRING(260)  ! SHACF_AUTOSUGGEST_FORCE_OFF + SHACF_AUTOAPPEND_FORCE_ON
M_Both    STRING(260)  ! SHACF_AUTOSUGGEST_FORCE_ON  + SHACF_AUTOAPPEND_FORCE_ON
M_Neither STRING(260)  ! SHACF_AUTOSUGGEST_FORCE_OFF + SHACF_AUTOAPPEND_FORCE_OFF
M_Wrong   STRING(260)  ! Specified SHACF_AUTOxxx without File or URL


EasyInpFile   string(260)  !SHACR_INPUT_FILE
EasyInpURL    string(260)  !SHACR_INPUT_URL
EasyInpAll    string(260)  !SHACR_INPUT_ALL


ClaEntry    string(255)
ClaText     string(260)
ClaCombo    string(255)


Window WINDOW('SHAC Explorer'),AT(,,273,136),FONT('MS Sans Serif',8,,FONT:regular),IMM,SYSTEM,GRAY,resize
       SHEET,AT(1,1,269,127),USE(?Sheet1)
         TAB('Easy Flags'),USE(?Tab:Examples)
           STRING('File:'),AT(8,21)
           TEXT,AT(27,21,213,10),USE(EasyInpFile),TIP('SHACR_INPUT_FILE'),SINGLE
           BUTTON,AT(244,20,16,12),USE(?PickFileBtn),SKIP,TIP('Open file dialog to pick file'),ICON(ICON:Ellipsis)
           STRING('URL:'),AT(8,37)
           TEXT,AT(27,37,213,10),USE(EasyInpURL),TIP('SHACR_INPUT_URL'),SINGLE
           STRING('All:'),AT(8,53)
           TEXT,AT(27,53,213,10),USE(EasyInpAll),TIP('SHACR_INPUT_ALL'),SINGLE
           STRING('Using Easy Equates SHAC_INPUT_ FILE, URL, and ALL'),AT(41,71),USE(?String24)
         END
         TAB('Fill Types'),USE(?Tab:Types)
           STRING('_Default'),AT(6,18)
           TEXT,AT(59,18,207,10),USE(T_DEFAULT),SINGLE
           STRING('_FileSystem'),AT(6,31)
           TEXT,AT(59,31,207,10),USE(T_FILESYSTEM),SINGLE
           STRING('_FileSys_Only'),AT(6,44)
           TEXT,AT(59,44,207,10),USE(T_FILESYS_ONLY),TIP('This didn''t work for me without +SHACF_FILESYSTEM'), |
               SINGLE
           STRING('_FileSys_Only *'),AT(6,57)
           TEXT,AT(59,57,207,10),USE(T_FILESYS_ONLY_A),TIP('SHACF_FILESYS_ONLY+SHACF_FILESYSTEM'),SINGLE
           STRING('_URLHistory'),AT(6,71)
           TEXT,AT(59,71,207,10),USE(T_URLHISTORY),SINGLE
           STRING('_URLMRU'),AT(6,84)
           TEXT,AT(59,84,207,10),USE(T_URLMRU),SINGLE
           STRING('_URLAll'),AT(6,97)
           TEXT,AT(59,97,207,10),USE(T_URLALL),SINGLE
           STRING('File+URLAll'),AT(6,110)
           TEXT,AT(59,110,207,10),USE(T_ALL),TIP('SHACF_FILESYSTEM+SHACF_URLALL'),SINGLE
         END
         TAB('Modes'),USE(?Tab:Modes)
           STRING('Default'),AT(6,18)
           TEXT,AT(43,18,223,10),USE(M_DEFAULT),TIP('No AUTO Equates'),SINGLE
           STRING('Suggest'),AT(6,31)
           TEXT,AT(43,31,223,10),USE(M_Suggest),TIP('SHACF_AUTOSUGGEST_FORCE_ON + SHACF_AUTOAPPEND_FORCE_OFF'), |
               SINGLE
           STRING('Append'),AT(6,44)
           TEXT,AT(43,44,223,10),USE(M_Append),TIP('SHACF_AUTOSUGGEST_FORCE_OFF + SHACF_AUTOAPPEND_FORCE_ON'), |
               SINGLE
           STRING('Both'),AT(6,57)
           TEXT,AT(43,57,223,10),USE(M_Both),TIP('SHACF_AUTOSUGGEST_FORCE_ON + SHACF_AUTOAPPEND_FORCE_ON'), |
               SINGLE
           STRING('Neither'),AT(6,71)
           TEXT,AT(43,71,223,10),USE(M_Neither),TIP('SHACF_AUTOSUGGEST_FORCE_OFF + SHACF_AUTOAPPEND_FORCE_OFF'), |
               SINGLE
           STRING('Wrong'),AT(6,85)
           TEXT,AT(43,85,223,10),USE(M_Wrong),TIP('Specified incorrectly|SHACF_DEFAULT + SHACF_AUTOSUGGEST_FORCE_ON  + SHACF_AUTOAP' &|
               'PEND_FORCE_OFF'),SINGLE
         END
         TAB('Clarion Controls'),USE(?Tab:Clarion)
           STRING('Clarion Control Types using SHAutoComplete'),AT(7,23),USE(?String13)
           STRING('Entry'),AT(8,41)
           ENTRY(@s255),AT(33,41,213,10),USE(ClaEntry)
           STRING('Text'),AT(8,61)
           TEXT,AT(33,61,213,10),USE(ClaText),SINGLE
           STRING('Combo'),AT(8,81)
           COMBO(@s255),AT(33,81,213,10),USE(ClaCombo),DROP(5),FROM('1|2|3')
         END
       END
     END


    code
    hr = CoInitialize()
    IF hr < 0 then Message('CoInitialize() failed hr=' & hr ).

    open(window)
    accept
        case event()
        of event:openwindow
           DO SHAC_Init_Rtn
        end
    end
    close(window)

    CoUninitialize()

SHAC_Init_Rtn   routine

     !---Clarion Controls Tab---------------
     !Show errors for these, for the rest skip it
     hr=SHAutoComplete( ?ClaEntry{prop:handle},0)
       if hr <> S_OK then
          setclipboard(hr)
          message('?ClaEntry hr=' & hr )
          !Error -2147024882 or 8007000Eh  happens if you forgot CoInitize
       end
     
     hr=SHAutoComplete( ?ClaText{prop:handle},0)  ;  if hr <> S_OK then message('?ClaText hr=' & hr ).
     hr=SHAutoComplete( ?ClaCombo{prop:handle},0) ;  if hr <> S_OK then message('?ClaCombo hr=' & hr ).

     !--SHACF_ Types'),USE(?Tab:Types)------------
     hr=SHAutoComplete( ?T_DEFAULT     {prop:handle},SHACF_DEFAULT )
     hr=SHAutoComplete( ?T_FILESYSTEM  {prop:handle},SHACF_FILESYSTEM )
     hr=SHAutoComplete( ?T_FILESYS_ONLY{prop:handle},SHACF_FILESYS_ONLY)
     hr=SHAutoComplete( ?T_FILESYS_ONLY_A{prop:handle},SHACF_FILESYS_ONLY+SHACF_FILESYSTEM )
     hr=SHAutoComplete( ?T_URLHISTORY  {prop:handle},SHACF_URLHISTORY )
     hr=SHAutoComplete( ?T_URLMRU      {prop:handle},SHACF_URLMRU )
     hr=SHAutoComplete( ?T_URLALL      {prop:handle},SHACF_URLALL )
     hr=SHAutoComplete( ?T_ALL         {prop:handle},SHACF_FILESYSTEM + SHACF_URLALL )

     !--Mode Equates
     hr=SHAutoComplete( ?M_DEFAULT  {prop:handle},SHACF_ALL + 0  )
     hr=SHAutoComplete( ?M_Suggest  {prop:handle},SHACF_ALL + SHACF_AUTOSUGGEST_FORCE_ON  + SHACF_AUTOAPPEND_FORCE_OFF )
     hr=SHAutoComplete( ?M_Append   {prop:handle},SHACF_ALL + SHACF_AUTOSUGGEST_FORCE_OFF + SHACF_AUTOAPPEND_FORCE_ON )
     hr=SHAutoComplete( ?M_Both     {prop:handle},SHACF_ALL + SHACF_AUTOSUGGEST_FORCE_ON  + SHACF_AUTOAPPEND_FORCE_ON )
     hr=SHAutoComplete( ?M_Neither  {prop:handle},SHACF_ALL + SHACF_AUTOSUGGEST_FORCE_OFF + SHACF_AUTOAPPEND_FORCE_OFF )
     hr=SHAutoComplete( ?M_Wrong    {prop:handle},SHACF_DEFAULT + SHACF_AUTOSUGGEST_FORCE_ON  + SHACF_AUTOAPPEND_FORCE_OFF )

     !--Easy Equate Examples using My Equates
     hr=SHAutoComplete( ?EasyInpFile{prop:handle},SHACR_INPUT_FILE)
     hr=SHAutoComplete( ?EasyInpURL {prop:handle},SHACR_INPUT_URL)
     hr=SHAutoComplete( ?EasyInpAll {prop:handle},SHACR_INPUT_ALL)

    EXIT
! SHAutoComplete
!  http://msdn.microsoft.com/library/default.asp?url=/library/en-us/shellcc/platform/shell/reference/shlwapi/version/shautocomplete.asp
!
!    Syntax
!
!    HRESULT SHAutoComplete(          HWND hwndEdit,
!        DWORD dwFlags
!    );
!    Parameters
!
!    hwndEdit
!    [in] Window handle of a system edit control. Typically, this parameter is the handle of an edit control or the edit control embedded in a ComboBoxEx control.
!    dwFlags
!    [in] Flags to control the operation of SHAutoComplete. The first four flags are used to override the Microsoft Internet Explorer registry settings. The user can change these settings manually by launching the Internet Options property sheet from the Tools menu and clicking the Advanced tab.
!    SHACF_AUTOAPPEND_FORCE_OFF
!       Ignore the registry default and force the autoappend feature off. This flag must be used in combination with one or more of the SHACF_FILESYS* or SHACF_URL* flags.
!    SHACF_AUTOAPPEND_FORCE_ON
!       Ignore the registry value and force the autoappend feature on. The completed string will be displayed in the edit box with the added characters highlighted. This flag must be used in combination with one or more of the SHACF_FILESYS* or SHACF_URL* flags.
!    SHACF_AUTOSUGGEST_FORCE_OFF
!       Ignore the registry default and force the autosuggest feature off. This flag must be used in combination with one or more of the SHACF_FILESYS* or SHACF_URL* flags.
!    SHACF_AUTOSUGGEST_FORCE_ON
!       Ignore the registry value and force the autosuggest feature on. A selection of possible completed strings will be displayed as a drop-down list, below the edit box. This flag must be used in combination with one or more of the SHACF_FILESYS* or SHACF_URL* flags.
!    SHACF_DEFAULT
!       The default setting, equivalent to SHACF_FILESYSTEM | SHACF_URLALL. SHACF_DEFAULT cannot be combined with any other flags.
!    SHACF_FILESYSTEM
!       Include the file system.
!    SHACF_URLALL
!       Include the URLs in the users History and Recently Used lists. Equivalent to SHACF_URLHISTORY | SHACF_URLMRU.
!    SHACF_URLHISTORY
!       Include the URLs in the user's History list.
!    SHACF_URLMRU
!       Include the URLs in the user's Recently Used list.
!    SHACF_USETAB
!       Allow the user to select from the autosuggest list by pressing the TAB key. If this flag is not set, pressing the TAB key will shift focus to the next control and close the autosuggest list. If SHACF_USETAB is set, pressing the TAB key will select the first item in the list. Pressing TAB again will select the next item in the list, and so on. When the user reaches the end of the list, the next TAB key press will cycle the focus back to the edit control. This flag must be used in combination with one or more of the SHACF_FILESYS* or SHACF_URL* flags.
!
!    Return Value
!       Returns S_OK if successful, or an error value otherwise.
!
!    Remarks
!
!    SHAutoComplete will work on any system edit control, including the edit control and controls that contain edit controls such as ComboBoxEx controls. To retrieve a handle to the edit control that is embedded in a ComboBoxEx control send it a CBEM_GETEDITCONTROL.
!
!    An application must have invoked either CoInitialize or OleInitialize prior to calling this function. CoUninitialize or OleUninitialize cannot be called until the edit box has finished processing the WM_DESTROY message for hwndEdit.
!
!
